<?php
/**
 * BBold functions and definitions.
*/

//CONSTANTS
if(!defined('HEROWP_THEME_DIR')) define( 'HEROWP_THEME_DIR', get_template_directory_uri() );

//Some hooks
require_once ('inc/widgets.php');
require_once ('inc/pagination.php');
require_once ('inc/multiple_sidebars.php');
require_once ('inc/class_theme_options.php');
require_once ('inc/meta-boxes.php');

//Call class that register the theme options
global $call_class_hero_wp_options;
$call_class_hero_wp_options = new HeroWP_Theme_Options;


//Enqueue scripts
function register_myway_styles()
{
wp_enqueue_style( 'reset', get_template_directory_uri().'/css/reset.css', array(), false, 'all');
wp_enqueue_style( 'style', get_template_directory_uri().'/style.css', array('bootstrap'), '1.0.0', 'all');
wp_enqueue_style( 'bootstrap', get_template_directory_uri().'/css/bootstrap.css', array(), '3.1.1', 'all');
wp_enqueue_style( 'responsive', get_template_directory_uri().'/css/responsive.css', array('style'), '1.0.0', 'all');
wp_enqueue_style( 'fontawesome', get_template_directory_uri().'/fonts/font-awesome/css/font-awesome.min.css', array('style'), '4.0.3', 'all');
wp_enqueue_style( 'shortcode', get_template_directory_uri().'/css/shortcode.css', array('style'), '1.0.0', 'all');
wp_enqueue_style( 'touchtouch', get_template_directory_uri().'/css/touchTouch.css', array('style'), false, 'all');
wp_enqueue_style( 'animate', get_template_directory_uri().'/css/animate.css', array('style'), false, 'all');
wp_enqueue_style( 'hover', get_template_directory_uri().'/css/hover-min.css', array('style'), false, 'all');
wp_enqueue_style( 'lightbox', get_template_directory_uri().'/css/lightbox.css', array('style'), false, 'all');
}

function register_myway_scripts()
{
// Register scripts
wp_enqueue_script( 'jquery', false, array(), null, true);
wp_enqueue_script( 'jqueryui_js', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.10.4/jquery-ui.min.js', array(), '2.2', true);
wp_enqueue_script( 'lightbox_js', get_template_directory_uri().'/js/lightbox.min.js', array(), '', true);
wp_enqueue_script( 'html5lightbox_js', get_template_directory_uri().'/js/html5lightbox.js', array(), '', true);
wp_enqueue_script( 'isotope_js', get_template_directory_uri().'/js/jquery.isotope.min.js', array(), '1.5.19', true);
wp_enqueue_script( 'touchtouch_js', get_template_directory_uri().'/js/touchTouch.jquery.js', array(), '1.0', true);
wp_enqueue_script( 'colorpicker_js', get_template_directory_uri().'/admin/color-picker/colpick.js', array(), '', false);
wp_enqueue_script( 'smoothscroll_js', get_template_directory_uri().'/js/jquery.smoothscroll.js', array(), '', true);
wp_enqueue_script( 'counterup_js', get_template_directory_uri().'/js/jquery.counterup.min.js', array(), '', true);
wp_enqueue_script( 'waypoints_js', get_template_directory_uri().'/js/waypoints.min.js', array(), '', true);
wp_enqueue_script( 'flexslider_js', get_template_directory_uri().'/js/jquery.flexslider.js', array(), '', true);
wp_enqueue_script( 'modernizr_js', get_template_directory_uri().'/js/modernizr.js', array(), '', true);
wp_enqueue_script( 'mousewheel_js', get_template_directory_uri().'/js/jquery.mousewheel.js', array(), '', true);
wp_enqueue_script( 'bootstrap_js', get_template_directory_uri().'/js/bootstrap.min.js', array(), '', true);
wp_enqueue_script( 'mixitup_js', get_template_directory_uri().'/js/jquery.mixitup.min.js', array(), '', true);
wp_enqueue_script( 'magnific-popup_js', get_template_directory_uri().'/js/jquery.magnific-popup.js', array(), '', true);
wp_enqueue_script( 'stellar_js', get_template_directory_uri().'/js/jquery.stellar.min.js', array(), '', true);
wp_enqueue_script( 'parallax_js', get_template_directory_uri().'/js/jquery.parallax-1.1.3.js', array(), '', true);
wp_enqueue_script( 'easing_js', get_template_directory_uri().'/js/jquery.easing.1.3.js', array(), '', true);
wp_enqueue_script( 'appear_js', get_template_directory_uri().'/js/jquery.appear.js', array(), '', true);
wp_enqueue_script( 'script_js', get_template_directory_uri().'/js/script.js', array(), '', true);	
}
add_action('wp_enqueue_scripts', 'register_myway_styles');
add_action('wp_enqueue_scripts', 'register_myway_scripts');

/**************************************************************************************
Load admin styles
*************************************************************************************/
function admin_enqueue_styles() {
        wp_enqueue_style( 'admin-styles', get_template_directory_uri() . '/css/admin-styles.css', false, 'all' );
}
add_action( 'admin_enqueue_scripts', 'admin_enqueue_styles' );



/*------------------------------------*\
	Theme Support
\*------------------------------------*/
if (!isset($content_width))
{
 $content_width = 900;
}
if (function_exists('add_theme_support'))
{
 // Add Menu Support
 add_theme_support('menus');
 // Add Thumbnail Theme Support
add_theme_support('post-thumbnails'); 
add_image_size('large', 700, '', true); // Large Thumbnail
add_image_size('medium', 250, '', true); // Medium Thumbnail
add_image_size('small', 120, '', true); // Small Thumbnail
add_image_size('custom-size', 700, 200, true); // Custom Thumbnail Size call using the_post_thumbnail('custom-size');
 // Enables post and comment RSS feed links to head
 add_theme_support('automatic-feed-links');
 // Localisation Support
 load_theme_textdomain('bbold-lite', get_template_directory(). '/languages');
}
/*------------------------------------*\
	Functions
\*------------------------------------*/
// Bbold navigation
class Menu_With_Description extends Walker_Nav_Menu {
	function start_el(&$output, $item, $depth = 0, $args = array(), $id = 0) {
		global $wp_query;
		$indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
		$class_names = $value = '';
		$classes = empty( $item->classes ) ? array() : (array) $item->classes;
		$class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item ) );
		$class_names = ' class="' . esc_attr( $class_names ) . '"';
		$output .= $indent . '<li id="menu-item-'. $item->ID . '"' . $value . $class_names .'>';
		$attributes = ! empty( $item->attr_title ) ? ' title="' . esc_attr( $item->attr_title ) .'"' : '';
		$attributes .= ! empty( $item->target ) ? ' target="' . esc_attr( $item->target ) .'"' : '';
		$attributes .= ! empty( $item->xfn ) ? ' rel="' . esc_attr( $item->xfn ) .'"' : '';
		$attributes .= ! empty( $item->url ) ? ' href="' . esc_attr( $item->url ) .'"' : '';
		@$item_output = $args->before;
		$item_output .= '<a'. $attributes .'>';
		@$item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID ) . $args->link_after;
		$item_output .= '<br /><span class="sub">' . $item->description . '</span>';
		$item_output .= '</a>';
		@$item_output .= $args->after;
		$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args, $id );
	}
}
class Menu_Mobile extends Walker_Nav_Menu {
	function start_el(&$output, $item, $depth = 0, $args = array(), $id = 0) {
		global $wp_query;
		$indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';
		$class_names = $value = '';
		$classes = empty( $item->classes ) ? array() : (array) $item->classes;
		$class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item ) );
		$class_names = ' class="' . esc_attr( $class_names ) . '"';
		$output .= $indent . '';
		$attributes .= ! empty( $item->url ) ? ' href="' . esc_attr( $item->url ) .'"' : '';
		$item_output .= '<option value="' . esc_attr( $item->url ) .'">';
		$item_output .= apply_filters( 'the_title', $item->title, $item->ID );
		$item_output .= '</option>';
		$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args, $id );
	}
}

function bbold_main_nav() {
	// display the wp3 menu if available
    wp_nav_menu(
    	array(
    		'theme_location' => 'header-menu', /* where in the theme it's assigned */
			'container' =>false,
			'menu_class' => 'sf-menu', /* menu class */
    		'fallback_cb' => 'bbold_main_nav_fallback' /* menu fallback */
    	)
    );
}
// Register BBold Navigation
function register_bbold_menu()
{
 register_nav_menus(array( // Using array to specify more menus if needed
 'header-menu' => __('Header Menu', 'bbold-lite'), // Main Navigation
 ));
}
add_action('init', 'register_bbold_menu'); // Add Menu

//Limit search to posts only 
function herowp_search_filter($query) {

    if ($query->is_search && !is_admin() ) {
        $query->set('post_type',array('post'));
    }

return $query;
}

add_filter('pre_get_posts','herowp_search_filter');

// Remove the <div> surrounding the dynamic navigation to cleanup markup
function my_wp_nav_menu_args($args = '')
{
 $args['container'] = false;
 return $args;
}

//custom wp_title() function
function hero_wp_theme_name_wp_title( $title, $sep ) {
	if ( is_feed() ) {
		return $title;
	}
	
	global $page, $paged;

	// Add the blog name
	$title .= get_bloginfo( 'name', 'display' );

	// Add the blog description for the home/front page.
	$site_description = get_bloginfo( 'description', 'display' );
	if ( $site_description && ( is_home() || is_front_page() ) ) {
		$title .= " $sep";
	}

	// Add a page number if necessary:
	if ( ( $paged >= 2 || $page >= 2 ) && ! is_404() ) {
		$title .= " $sep " . sprintf( __( 'Page %s', '_s' ), max( $paged, $page ) );
	}

	return $title;
}
add_filter( 'wp_title', 'hero_wp_theme_name_wp_title', 10, 2 );

// Remove Injected classes, ID's and Page ID's from Navigation <li> items
function my_css_attributes_filter($var)
{
 return is_array($var) ? array() : '';
}
// Remove invalid rel attribute values in the categorylist
function remove_category_rel_from_category_list($thelist)
{
 return str_replace('rel="category tag"', 'rel="tag"', $thelist);
}
// Add page slug to body class, love this - Credit: Starkers Wordpress Theme
function add_slug_to_body_class($classes)
{
 global $post;
 if (is_home()) {
 $key = array_search('blog', $classes);
 if ($key > -1) {
 unset($classes[$key]);
 }
 } elseif (is_page()) {
 $classes[] = sanitize_html_class($post->post_name);
 } elseif (is_singular()) {
 $classes[] = sanitize_html_class($post->post_name);
 }
 return $classes;
}
/**
 * Register our sidebars and widgetized areas.
 *
 */
function herowp_widgets_init() {
	
	register_sidebar( array(
		'name' => 'Sidebar',
		'id' => 'sidebar',
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div>',
		'before_title' => '<h3>',
		'after_title' => '<span class="dotcolor">.</span></h3>',
	) );	
	register_sidebar( array(
		'name' => 'First Footer Widget Area',
		'id' => 'first_footer',
		'before_widget' => '<div id="%1$s" class=" %2$s">',
		'after_widget' => '</div>',
		'before_title' => '<div class="title"><h3>',
		'after_title' => '<span class="dotcolor">.</span></h3></div>
						  
						  <div class="footer-box-line2"></div>
		',
	) );	
	register_sidebar( array(
		'name' => 'Second Footer Widget Area',
		'id' => 'second_footer',
		'before_widget' => '<div id="%1$s" class="%2$s">',
		'after_widget' => '</div>',
		'before_title' => '<div class="title"><h3>',
		'after_title' => '<span class="dotcolor">.</span></h3></div>
						  
						  <div class="footer-box-line2"></div>
		',
	) );
	
	register_sidebar( array(
		'name' => 'Third Footer Widget Area',
		'id' => 'third_footer',
		'before_widget' => '<div id="%1$s" class="%2$s">',
		'after_widget' => '</div>',
		'before_title' => '<div class="title"><h3>',
		'after_title' => '<span class="dotcolor">.</span></h3></div>
						  
						  <div class="footer-box-line2"></div>
		',
	) );
	
	register_sidebar( array(
		'name' => 'Contact Sidebar',
		'id' => 'contact_sidebar',
		'before_widget' => '<div id="%1$s" class="%2$s">',
		'after_widget' => '</div>',
		'before_title' => '<div class="title"><h3>',
		'after_title' => '<span class="dotcolor">.</span></h3></div>
						  
						  <div class="footer-box-line2"></div>
		',
	) );	
		
	
}
add_action( 'widgets_init', 'herowp_widgets_init' );
// Remove wp_head() injected Recent Comment styles
function my_remove_recent_comments_style()
{
 global $wp_widget_factory;
 remove_action('wp_head', array(
 $wp_widget_factory->widgets['WP_Widget_Recent_Comments'],
 'recent_comments_style'
 ));
}

//set tags to same font size no matter how many times is being used
add_filter( 'widget_tag_cloud_args', 'herowp_tag_cloud_same_size' );
function herowp_tag_cloud_same_size($in){
return 'smallest=12&largest=12&number=25&orderby=name&unit=px';
}


//custom excerpt length
function excerpt($limit) {
 $excerpt = explode(' ', get_the_excerpt(), $limit);
 if (count($excerpt)>=$limit) {
 array_pop($excerpt);
 $excerpt = implode(" ",$excerpt).'...';
 } else {
 $excerpt = implode(" ",$excerpt);
 }
 $excerpt = preg_replace('`[[^]]*]`','',$excerpt);
 return $excerpt;
}

function content($limit) {
 $content = explode(' ', get_the_content(), $limit);
 if (count($content)>=$limit) {
 array_pop($content);
 $content = implode(" ",$content).'...';
 } else {
 $content = implode(" ",$content);
 }
 $content = preg_replace('/[.+]/','', $content);
 $content = apply_filters('the_content', $content);
 $content = str_replace(']]>', ']]&gt;', $content);
 return $content;
}
//custom excerpt length for full screen blog posts
remove_filter('get_the_excerpt', 'wp_trim_excerpt');
function custom_excerpt_length($text) {
	global $post;
	if ( '' == $text ) {
		$text = get_the_content('');
		$text = apply_filters('the_content', $text);
		$text = str_replace(']]>', ']]>', $text);
		$text = strip_tags($text);
		$excerpt_length = 90;
		$words = explode(' ', $text, $excerpt_length + 1);
		if (count($words) > $excerpt_length) {
			array_pop($words);
			array_push($words, '...');
			$text = implode(' ', $words);
		}
	}
	return $text;
}
add_filter('get_the_excerpt', 'custom_excerpt_length');

// Pagination for paged posts, Page 1, Page 2, Page 3, with Next and Previous Links
function herowp_numeric_posts_nav() {

	if( is_singular() )
		return;

	global $wp_query;

	/** Stop execution if there's only 1 page */
	if( $wp_query->max_num_pages <= 1 )
		return;

	$paged = get_query_var( 'paged' ) ? absint( get_query_var( 'paged' ) ) : 1;
	$max   = intval( $wp_query->max_num_pages );

	/**	Add current page to the array */
	if ( $paged >= 1 )
		$links[] = $paged;

	/**	Add the pages around the current page to the array */
	if ( $paged >= 3 ) {
		$links[] = $paged - 1;
		$links[] = $paged - 2;
	}

	if ( ( $paged + 2 ) <= $max ) {
		$links[] = $paged + 2;
		$links[] = $paged + 1;
	}

	echo '<div class="pagination_navigation"><ul>' . "\n";

	/**	Previous Post Link */
	if ( get_previous_posts_link() )
		printf( '<li>%s</li>' . "\n", get_previous_posts_link('&laquo;') );

	/**	Link to first page, plus ellipses if necessary */
	if ( ! in_array( 1, $links ) ) {
		$class = 1 == $paged ? ' class="active"' : '';

		printf( '<li%s><a href="%s">%s</a></li>' . "\n", $class, esc_url( get_pagenum_link( 1 ) ), '1' );

		if ( ! in_array( 2, $links ) )
			echo '<li>...</li>';
	}

	/**	Link to current page, plus 2 pages in either direction if necessary */
	sort( $links );
	foreach ( (array) $links as $link ) {
		$class = $paged == $link ? ' class="active"' : '';
		printf( '<li%s><a href="%s">%s</a></li>' . "\n", $class, esc_url( get_pagenum_link( $link ) ), $link );
	}

	/**	Link to last page, plus ellipses if necessary */
	if ( ! in_array( $max, $links ) ) {
		if ( ! in_array( $max - 1, $links ) )
			echo '<li>...</li>' . "\n";

		$class = $paged == $max ? ' class="active"' : '';
		printf( '<li%s><a href="%s">%s</a></li>' . "\n", $class, esc_url( get_pagenum_link( $max ) ), $max );
	}

	/**	Next Post Link */
	if ( get_next_posts_link() )
		printf( '<li>%s</li>' . "\n", get_next_posts_link('&raquo;') );

	echo '</ul></div>' . "\n";

}

/* ********************
* Limit post excerpts. Within theme files used as
* print string_limit_words(get_the_excerpt(), 20);
******************************************************************** */
function string_limit_words($string, $word_limit) {
$words = explode(' ', $string, ($word_limit + 1));
if(count($words) > $word_limit)
array_pop($words);
return implode(' ', $words);
}
if ( is_admin() ) {
    show_admin_bar( true );
}
// Remove 'text/css' from our enqueued stylesheet
function myway_style_remove($tag)
{
 return preg_replace('~\s+type=["\'][^"\']++["\']~', '', $tag);
}
// Remove thumbnail width and height dimensions that prevent fluid images in the_thumbnail
function remove_thumbnail_dimensions( $html )
{
 $html = preg_replace('/(width|height)=\"\d*\"\s/', "", $html);
 return $html;
}
// Custom Gravatar in Settings > Discussion
function mywaygravatar ($avatar_defaults)
{
 $myavatar = get_template_directory_uri() . '/img/gravatar.jpg';
 $avatar_defaults[$myavatar] = "Custom Gravatar";
 return $avatar_defaults;
}
// Threaded Comments
function enable_threaded_comments()
{
 if (!is_admin()) {
 if (is_singular() AND comments_open() AND (get_option('thread_comments') == 1)) {
 wp_enqueue_script('comment-reply');
 }
 }
}
/*------------------------------------*\
	Actions + Filters + ShortCodes
\*------------------------------------*/
// Add Actions
//add_action('init', 'myway_header_scripts'); // Add Custom Scripts to wp_head
//add_action('wp_print_scripts', 'myway_conditional_scripts'); // Add Conditional Page Scripts
add_action('get_header', 'enable_threaded_comments'); // Enable Threaded Comments
add_action('widgets_init', 'my_remove_recent_comments_style'); // Remove inline Recent Comment Styles from wp_head()
// Remove Actions
remove_action('wp_head', 'feed_links_extra', 3); // Display the links to the extra feeds such as category feeds
remove_action('wp_head', 'feed_links', 2); // Display the links to the general feeds: Post and Comment Feed
remove_action('wp_head', 'rsd_link'); // Display the link to the Really Simple Discovery service endpoint, EditURI link
remove_action('wp_head', 'wlwmanifest_link'); // Display the link to the Windows Live Writer manifest file.
remove_action('wp_head', 'index_rel_link'); // Index link
remove_action('wp_head', 'parent_post_rel_link', 10, 0); // Prev link
remove_action('wp_head', 'start_post_rel_link', 10, 0); // Start link
remove_action('wp_head', 'adjacent_posts_rel_link', 10, 0); // Display relational links for the posts adjacent to the current post.
remove_action('wp_head', 'wp_generator'); // Display the XHTML generator that is generated on the wp_head hook, WP version
remove_action('wp_head', 'start_post_rel_link', 10, 0);
remove_action('wp_head', 'adjacent_posts_rel_link_wp_head', 10, 0);
remove_action('wp_head', 'rel_canonical');
remove_action('wp_head', 'wp_shortlink_wp_head', 10, 0);
// Add Filters
add_filter('avatar_defaults', 'mywaygravatar'); // Custom Gravatar in Settings > Discussion
add_filter('body_class', 'add_slug_to_body_class'); // Add slug to body class (Starkers build)
add_filter('widget_text', 'do_shortcode'); // Allow shortcodes in Dynamic Sidebar
add_filter('widget_text', 'shortcode_unautop'); // Remove <p> tags in Dynamic Sidebars (better!)
add_filter('wp_nav_menu_args', 'my_wp_nav_menu_args'); // Remove surrounding <div> from WP Navigation
// add_filter('nav_menu_css_class', 'my_css_attributes_filter', 100, 1); // Remove Navigation <li> injected classes (Commented out by default)
// add_filter('nav_menu_item_id', 'my_css_attributes_filter', 100, 1); // Remove Navigation <li> injected ID (Commented out by default)
// add_filter('page_css_class', 'my_css_attributes_filter', 100, 1); // Remove Navigation <li> Page ID's (Commented out by default)
add_filter('the_category', 'remove_category_rel_from_category_list'); // Remove invalid rel attribute
add_filter('the_excerpt', 'shortcode_unautop'); // Remove auto <p> tags in Excerpt (Manual Excerpts only)
add_filter('the_excerpt', 'do_shortcode'); // Allows Shortcodes to be executed in Excerpt (Manual Excerpts only)
add_filter('style_loader_tag', 'myway_style_remove'); // Remove 'text/css' from enqueued stylesheet
add_filter('post_thumbnail_html', 'remove_thumbnail_dimensions', 10); // Remove width and height dynamic attributes to thumbnails
add_filter('image_send_to_editor', 'remove_thumbnail_dimensions', 10); // Remove width and height dynamic attributes to post images
// Remove Filters
remove_filter('the_excerpt', 'wpautop'); // Remove <p> tags from Excerpt altogether
// Shortcodes above would be nested like this -
// [myway_shortcode_demo] [myway_shortcode_demo_2] Here's the page title! [/myway_shortcode_demo_2] [/myway_shortcode_demo]
/*------------------------------------*\
	ShortCode Functions
\*------------------------------------*/
// Shortcode Demo with Nested Capability
function myway_shortcode_demo($atts, $content = null)
{
 return '<div class="shortcode-demo">' . do_shortcode($content) . '</div>'; // do_shortcode allows for nested Shortcodes
}
// Shortcode Demo with simple <h2> tag
function myway_shortcode_demo_2($atts, $content = null) // Demo Heading H2 shortcode, allows for nesting within above element. Fully expandable.
{
 return '<h2>' . $content . '</h2>';
}
/*------------------------------------*\
	AqResize Functions
\*------------------------------------*/
if(!class_exists('Aq_Resize')) {
 class Aq_Resize
 {
 /**
 * The singleton instance
 */
 static private $instance = null;
 /**
 * No initialization allowed
 */
 private function __construct() {}
 /**
 * No cloning allowed
 */
 private function __clone() {}
 /**
 * For your custom default usage you may want to initialize an Aq_Resize object by yourself and then have own defaults
 */
 static public function getInstance() {
 if(self::$instance == null) {
 self::$instance = new self;
 }
 return self::$instance;
 }
 /**
 * Run, forest.
 */
 public function process( $url, $width = null, $height = null, $crop = null, $single = true, $upscale = false ) {
 // Validate inputs.
 if ( ! $url || ( ! $width && ! $height ) ) return false;
 // Caipt'n, ready to hook.
 if ( true === $upscale ) add_filter( 'image_resize_dimensions', array($this, 'aq_upscale'), 10, 6 );
 // Define upload path & dir.
 $upload_info = wp_upload_dir();
 $upload_dir = $upload_info['basedir'];
 $upload_url = $upload_info['baseurl'];
 
 $http_prefix = "http://";
 $https_prefix = "https://";
 
 /* if the $url scheme differs from $upload_url scheme, make them match 
 if the schemes differe, images don't show up. */
 if(!strncmp($url,$https_prefix,strlen($https_prefix))){ //if url begins with https:// make $upload_url begin with https:// as well
 $upload_url = str_replace($http_prefix,$https_prefix,$upload_url);
 }
 elseif(!strncmp($url,$http_prefix,strlen($http_prefix))){ //if url begins with http:// make $upload_url begin with http:// as well
 $upload_url = str_replace($https_prefix,$http_prefix,$upload_url); 
 }
 
 // Check if $img_url is local.
 if ( false === strpos( $url, $upload_url ) ) return false;
 // Define path of image.
 $rel_path = str_replace( $upload_url, '', $url );
 $img_path = $upload_dir . $rel_path;
 // Check if img path exists, and is an image indeed.
 if ( ! file_exists( $img_path ) or ! getimagesize( $img_path ) ) return false;
 // Get image info.
 $info = pathinfo( $img_path );
 $ext = $info['extension'];
 list( $orig_w, $orig_h ) = getimagesize( $img_path );
 // Get image size after cropping.
 $dims = image_resize_dimensions( $orig_w, $orig_h, $width, $height, $crop );
 $dst_w = $dims[4];
 $dst_h = $dims[5];
 // Return the original image only if it exactly fits the needed measures.
 if ( ! $dims && ( ( ( null === $height && $orig_w == $width ) xor ( null === $width && $orig_h == $height ) ) xor ( $height == $orig_h && $width == $orig_w ) ) ) {
 $img_url = $url;
 $dst_w = $orig_w;
 $dst_h = $orig_h;
 } else {
 // Use this to check if cropped image already exists, so we can return that instead.
 $suffix = "{$dst_w}x{$dst_h}";
 $dst_rel_path = str_replace( '.' . $ext, '', $rel_path );
 $destfilename = "{$upload_dir}{$dst_rel_path}-{$suffix}.{$ext}";
 if ( ! $dims || ( true == $crop && false == $upscale && ( $dst_w < $width || $dst_h < $height ) ) ) {
 // Can't resize, so return false saying that the action to do could not be processed as planned.
 return false;
 }
 // Else check if cache exists.
 elseif ( file_exists( $destfilename ) && getimagesize( $destfilename ) ) {
 $img_url = "{$upload_url}{$dst_rel_path}-{$suffix}.{$ext}";
 }
 // Else, we resize the image and return the new resized image url.
 else {
 $editor = wp_get_image_editor( $img_path );
 if ( is_wp_error( $editor ) || is_wp_error( $editor->resize( $width, $height, $crop ) ) )
 return false;
 $resized_file = $editor->save();
 if ( ! is_wp_error( $resized_file ) ) {
 $resized_rel_path = str_replace( $upload_dir, '', $resized_file['path'] );
 $img_url = $upload_url . $resized_rel_path;
 } else {
 return false;
 }
 }
 }
 // Okay, leave the ship.
 if ( true === $upscale ) remove_filter( 'image_resize_dimensions', array( $this, 'aq_upscale' ) );
 // Return the output.
 if ( $single ) {
 // str return.
 $image = $img_url;
 } else {
 // array return.
 $image = array (
 0 => $img_url,
 1 => $dst_w,
 2 => $dst_h
 );
 }
 return $image;
 }
 /**
 * Callback to overwrite WP computing of thumbnail measures
 */
 function aq_upscale( $default, $orig_w, $orig_h, $dest_w, $dest_h, $crop ) {
 if ( ! $crop ) return null; // Let the wordpress default function handle this.
 // Here is the point we allow to use larger image size than the original one.
 $aspect_ratio = $orig_w / $orig_h;
 $new_w = $dest_w;
 $new_h = $dest_h;
 if ( ! $new_w ) {
 $new_w = intval( $new_h * $aspect_ratio );
 }
 if ( ! $new_h ) {
 $new_h = intval( $new_w / $aspect_ratio );
 }
 $size_ratio = max( $new_w / $orig_w, $new_h / $orig_h );
 $crop_w = round( $new_w / $size_ratio );
 $crop_h = round( $new_h / $size_ratio );
 $s_x = floor( ( $orig_w - $crop_w ) / 2 );
 $s_y = floor( ( $orig_h - $crop_h ) / 2 );
 return array( 0, 0, (int) $s_x, (int) $s_y, (int) $new_w, (int) $new_h, (int) $crop_w, (int) $crop_h );
 }
 }
}
if(!function_exists('aq_resize')) {
 /**
 * This is just a tiny wrapper function for the class above so that there is no
 * need to change any code in your own WP themes. Usage is still the same :)
 */
 function aq_resize( $url, $width = null, $height = null, $crop = null, $single = true, $upscale = false ) {
 $aq_resize = Aq_Resize::getInstance();
 return $aq_resize->process( $url, $width, $height, $crop, $single, $upscale );
 }
}
function title_excerpt( $length ) {
	$excerpt = explode( ' ', get_the_title(), $length );
	if ( count( $excerpt ) >= $length ) {
		array_pop( $excerpt );
		$excerpt = implode( " ", $excerpt );
	} else {
		$excerpt = implode( " ", $excerpt );
	}
	$excerpt = preg_replace( '`\[[^\]]*\]`', '', $excerpt );
	return $excerpt.'';
}



//convert HEX to RGBA function
function hex2rgba($hex, $alpha = 1)
{
	$hex = str_replace('#', '', $hex);
	$r = $g = $b = 0;

	switch(strlen($hex)){
		case 3:
			list($r, $g, $b) = str_split($hex);
			$r = hexdec($r.$r);
			$g = hexdec($g.$g);
			$b = hexdec($b.$b);
			break;
		case 6:
			list($r1, $r2, $g1, $g2, $b1, $b2) = str_split($hex);
			$r = hexdec($r1.$r2);
			$g = hexdec($g1.$g2);
			$b = hexdec($b1.$b2);
			break;
		default:
			break;
	}

	return 'rgba('.$r.', '.$g.', '.$b.', '.$alpha.')';
}


if ( ! function_exists( 'twentytwelve_content_nav' ) ) :
/**
 * Displays navigation to next/previous pages when applicable.
 *
 * @since Twenty Twelve 1.0
 */
function twentytwelve_content_nav() {
	global $wp_query;
	if ( $wp_query->max_num_pages > 1 ) : ?>
		<?php previous_posts_link( '<i class="fa fa-angle-left"></i>'.__( '', 'bbold-lite' ) ); ?>
		<?php next_posts_link( '<i class="fa fa-angle-right"></i>'.__( '', 'bbold-lite' ) ); ?>
	<?php endif;
}
endif;

if ( ! function_exists( 'herowp_comment' ) ) :
/**
 * Template for comments and pingbacks.
 *
 * To override this walker in a child theme without modifying the comments template
 * simply create your own herowp_comment(), and that function will be used instead.
 *
 * Used as a callback by wp_list_comments() for displaying the comments.
 */
function herowp_comment( $comment, $args, $depth ) {
	$GLOBALS['comment'] = $comment;
	switch ( $comment->comment_type ) :
		case 'pingback' :
		case 'trackback' :
	?>
	<li class="post pingback">
		<p><?php _e( 'Pingback:', 'bbold-lite' ); ?> <?php comment_author_link(); ?><?php edit_comment_link( __( 'Edit', 'bbold-lite' ), '<span class="edit-link">', '</span>' ); ?></p>
	<?php
			break;
		default :
	?>
	<!-- comment level 1 -->
	<div class="comment-container">
		<div class="comment-author"><?php echo get_avatar( $comment, 64 ); ?><i class="pe-7f-user"></i> <?php comment_author_link(); ?></div>
		<div class="date_reply_holder">
			<div class="comment-date"><i class="pe-7f-date"></i> <?php comment_date("d M Y"); ?></div>
			<div class="comment-reply"><i class="pe-7f-refresh"></i> <?php echo comment_reply_link(array('depth' => $depth, 'max_depth' => $args['max_depth'],'reply_text'=>'Reply Comment')); ?></div>
		</div>
		<div class="the-comment"><?php comment_text(); ?></div>
	</div>
	<?php
			break;
	endswitch;
}
endif; // ends check for herowp_comment()

/*
 * Function creates post duplicate as a draft and redirects then to the edit post screen
 */
function herowp_duplicate_post_as_draft(){
	global $wpdb;
	if (! ( isset( $_GET['post']) || isset( $_POST['post'])  || ( isset($_REQUEST['action']) && 'herowp_duplicate_post_as_draft' == $_REQUEST['action'] ) ) ) {
		wp_die('No post to duplicate has been supplied!');
	}
 
	/*
	 * get the original post id
	 */
	$post_id = (isset($_GET['post']) ? $_GET['post'] : $_POST['post']);
	/*
	 * and all the original post data then
	 */
	$post = get_post( $post_id );
 
	/*
	 * if you don't want current user to be the new post author,
	 * then change next couple of lines to this: $new_post_author = $post->post_author;
	 */
	$current_user = wp_get_current_user();
	$new_post_author = $current_user->ID;
 
	/*
	 * if post data exists, create the post duplicate
	 */
	if (isset( $post ) && $post != null) {
 
		/*
		 * new post data array
		 */
		$args = array(
			'comment_status' => $post->comment_status,
			'ping_status'    => $post->ping_status,
			'post_author'    => $new_post_author,
			'post_content'   => $post->post_content,
			'post_excerpt'   => $post->post_excerpt,
			'post_name'      => $post->post_name,
			'post_parent'    => $post->post_parent,
			'post_password'  => $post->post_password,
			'post_status'    => 'draft',
			'post_title'     => $post->post_title,
			'post_type'      => $post->post_type,
			'to_ping'        => $post->to_ping,
			'menu_order'     => $post->menu_order
		);
 
		/*
		 * insert the post by wp_insert_post() function
		 */
		$new_post_id = wp_insert_post( $args );
 
		/*
		 * get all current post terms ad set them to the new post draft
		 */
		$taxonomies = get_object_taxonomies($post->post_type); // returns array of taxonomy names for post type, ex array("category", "post_tag");
		foreach ($taxonomies as $taxonomy) {
			$post_terms = wp_get_object_terms($post_id, $taxonomy, array('fields' => 'slugs'));
			wp_set_object_terms($new_post_id, $post_terms, $taxonomy, false);
		}
 
		/*
		 * duplicate all post meta
		 */
		$post_meta_infos = $wpdb->get_results("SELECT meta_key, meta_value FROM $wpdb->postmeta WHERE post_id=$post_id");
		if (count($post_meta_infos)!=0) {
			$sql_query = "INSERT INTO $wpdb->postmeta (post_id, meta_key, meta_value) ";
			foreach ($post_meta_infos as $meta_info) {
				$meta_key = $meta_info->meta_key;
				$meta_value = addslashes($meta_info->meta_value);
				$sql_query_sel[]= "SELECT $new_post_id, '$meta_key', '$meta_value'";
			}
			$sql_query.= implode(" UNION ALL ", $sql_query_sel);
			$wpdb->query($sql_query);
		}
 
 
		/*
		 * finally, redirect to the edit post screen for the new draft
		 */
		wp_redirect( admin_url( 'post.php?action=edit&post=' . $new_post_id ) );
		exit;
	} else {
		wp_die('Post creation failed, could not find original post: ' . $post_id);
	}
}
add_action( 'admin_action_herowp_duplicate_post_as_draft', 'herowp_duplicate_post_as_draft' );
 
/*
 * Add the duplicate link to action list for post_row_actions
 */
function herwowp_duplicate_post_link( $actions, $post ) {
	if (current_user_can('edit_posts')) {
		$actions['duplicate'] = '<a href="admin.php?action=herowp_duplicate_post_as_draft&amp;post=' . $post->ID . '" title="Duplicate this item" rel="permalink">Duplicate</a>';
	}
	return $actions;
}
 
add_filter( 'post_row_actions', 'herwowp_duplicate_post_link', 10, 2 );
?>