<?php
/**
*
* Begining of class HeroWP_Theme_Options 
*
*/
class HeroWP_Theme_Options{

	
	function __construct(){
	
		add_action( 'admin_menu', array(&$this,'herowp_register_menu_page'));
		add_action( 'admin_enqueue_scripts', array(&$this,'herowp_admin_add_scripts'));
		add_action( 'admin_init', array(&$this,'herowp_register_options_group'));
		
	}


	/**
	*
	* We register the page in the menu
	*
	*/
	function herowp_register_menu_page(){
	
		add_theme_page( 'Theme Options', 'Theme Options', 'manage_options', 'change_login_logo', array(&$this,'herowp_create_settings_page'), HEROWP_THEME_DIR.'/images/icon.png', 99 );
	
	}
	
	
	/**
	*
	* We enqueue the required scripts
	*
	*/	
	function herowp_admin_add_scripts() {
	
		wp_enqueue_media();
        wp_register_script( 'uploader', HEROWP_THEME_DIR.'/js/uploader.js', array('jquery'));
        wp_enqueue_script( 'uploader' );
		wp_enqueue_script( 'wp-color-picker' );
		wp_enqueue_style( 'wp-color-picker' );
		
	}
	
	
	/**
	*
	* We register the options
	*
	*/	
	function herowp_register_options_group() {
		
		register_setting( 'herowp-login-options-group', 'herowp_logo');
		register_setting( 'herowp-login-options-group', 'herowp_bg_width');
		register_setting( 'herowp-login-options-group', 'herowp_bg_height');
		register_setting( 'herowp-login-options-group', 'herowp_base_color');
		register_setting( 'herowp-login-options-group', 'herowp_gr_01_color');
		register_setting( 'herowp-login-options-group', 'herowp_gr_02_color');
		register_setting( 'herowp-login-options-group', 'herowp_custom_css');
		register_setting( 'herowp-login-options-group', 'herowp_google_analytics');
		register_setting( 'herowp-login-options-group', 'herowp_blog_title');
		register_setting( 'herowp-login-options-group', 'herowp_blog_subtitle');
		register_setting( 'herowp-login-options-group', 'herowp_footer_small_phone');
		register_setting( 'herowp-login-options-group', 'herowp_footer_big_bold_phone');
		register_setting( 'herowp-login-options-group', 'herowp_footer_big_phone');
		register_setting( 'herowp-login-options-group', 'herowp_footer_copyright');

		
	}
	

	/**
	*
	* We create the settings page
	*
	*/
	function herowp_create_settings_page(){?>
			
			<form method="post" action="options.php"><!--START THE FORM-->
				
				<?php settings_fields( 'herowp-login-options-group' ); ?>
				
				<h2><?php _e( 'Theme Options', 'bbold-lite' ); ?></h2>
				
				<?php if( isset($_GET['settings-updated']) ) { ?>
					<div id="message" class="updated">
						<p><strong><?php _e('Settings saved.','bbold-lite') ?></strong></p>
					</div>
				<?php } ?>
				
				<table class="form-table"><!--START TABLE-->
				
					<tr valign="top">
						<th scope="row"><?php _e( 'Main Logo', 'bbold-lite' ); ?></th>
							<td>
								<label for="upload_image">
									<input id="upload_image" type="text" size="36" name="herowp_logo" value="<?php echo get_option('herowp_logo'); ?>" /> 
									<input id="upload_image_button" class="button" type="button" value="Upload Image" />
									<br />Enter a URL or upload an image
								</label>
							</td>
					</tr>
					
					<tr valign="top">
						<th scope="row"><?php _e( 'Base Color.', 'bbold-lite' ); ?></th>
						<td><label for="herowp_base_color">
							<input type="text" id="herowp_base_color" size="36" class="color-picker" name="herowp_base_color" value="<?php echo get_option( 'herowp_base_color' ); ?>" />
							<p class="description"><?php _e( 'This is the base theme color. If blank, the default color will be used.', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>					
					
					<tr valign="top">
						<th scope="row"><?php _e( 'First Gradient Color.', 'bbold-lite' ); ?></th>
						<td><label for="herowp_gr_01_color">
							<input type="text" id="herowp_gr_01_color" size="36" class="color-picker" name="herowp_gr_01_color" value="<?php echo get_option( 'herowp_gr_01_color' ); ?>" />
							<p class="description"><?php _e( 'This is the header first gradient color. If blank, the default color will be used.', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>					
					
					<tr valign="top">
						<th scope="row"><?php _e( 'Second Gradient Color.', 'bbold-lite' ); ?></th>
						<td><label for="herowp_gr_02_color">
							<input type="text" id="herowp_gr_02_color" size="36" class="color-picker" name="herowp_gr_02_color" value="<?php echo get_option( 'herowp_gr_02_color' ); ?>" />
							<p class="description"><?php _e( 'This is the header second gradient color. If blank, the default color will be used.', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>
					
					<tr valign="top">
						<th scope="row"><?php _e( 'Custom CSS Code', 'bbold-lite' ); ?></th>
						<td><label for="herowp_custom_css">
							<textarea id="herowp_custom_css" rows="5" cols="36" name="herowp_custom_css" />
								<?php echo get_option( 'herowp_custom_css' ); ?>
							</textarea>
							<p class="description"><?php _e( 'Add your own CSS here. Do NOT modify main stlye.css, or you\'ll lose modifications on theme update.', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>					
					
					<tr valign="top">
						<th scope="row"><?php _e( 'Google Analytics Code', 'bbold-lite' ); ?></th>
						<td><label for="herowp_google_analytics">
							<textarea id="herowp_google_analytics" rows="5" cols="36" name="herowp_google_analytics" />
								<?php echo get_option( 'herowp_google_analytics' ); ?>
							</textarea>
							<p class="description"><?php _e( 'Add your Google Analytics Code here.', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>	

					<tr valign="top">
						<th scope="row"><?php _e( 'Blog title text', 'bbold-lite' ); ?></th>
						<td><label for="herowp_blog_title">
							<input type="text" id="herowp_blog_title" size="36" name="herowp_blog_title" value="<?php echo get_option( 'herowp_blog_title' ); ?>" />
							<p class="description"><?php _e( 'This is the page title that appears on your blog page', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>						
					
					<tr valign="top">
						<th scope="row"><?php _e( 'Blog subtitle text', 'bbold-lite' ); ?></th>
						<td><label for="herowp_blog_subtitle">
							<input type="text" id="herowp_blog_subtitle" size="36" name="herowp_blog_subtitle" value="<?php echo get_option( 'herowp_blog_subtitle' ); ?>" />
							<p class="description"><?php _e( 'This is the text that is displayed bellow blog page titles, such as archives, tags etc.', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>					
					
					<tr valign="top">
						<th scope="row"><?php _e( 'Footer above phone text', 'bbold-lite' ); ?></th>
						<td><label for="herowp_footer_small_phone">
							<input type="text" id="herowp_footer_small_phone" size="36" name="herowp_footer_small_phone" value="<?php echo get_option( 'herowp_footer_small_phone' ); ?>" />
							<p class="description"><?php _e( 'This is the text that is displayed above footer phone. Leave blank for no text.', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>					
					
					<tr valign="top">
						<th scope="row"><?php _e( 'Footer prefix phone number', 'bbold-lite' ); ?></th>
						<td><label for="herowp_footer_big_bold_phone">
							<input type="text" id="herowp_footer_big_bold_phone" size="36" name="herowp_footer_big_bold_phone" value="<?php echo get_option( 'herowp_footer_big_bold_phone' ); ?>" />
							<p class="description"><?php _e( 'Add footer prfeix phone number. Leave blank for no number.', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>					
					
					<tr valign="top">
						<th scope="row"><?php _e( 'Footer phone number', 'bbold-lite' ); ?></th>
						<td><label for="herowp_footer_big_phone">
							<input type="text" id="herowp_footer_big_phone" size="36" name="herowp_footer_big_phone" value="<?php echo get_option( 'herowp_footer_big_phone' ); ?>" />
							<p class="description"><?php _e( 'Add footer phone number. Leave blank for no number.', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>					
					
					<tr valign="top">
						<th scope="row"><?php _e( 'Footer copyright', 'bbold-lite' ); ?></th>
						<td><label for="herowp_footer_copyright">
							<input type="text" id="herowp_footer_copyright" size="36" name="herowp_footer_copyright" value="<?php echo get_option( 'herowp_footer_copyright' ); ?>" />
							<p class="description"><?php _e( 'Add footer copyright text. ', 'bbold-lite' ); ?></p>
							</label>
						</td>
					</tr>

					<tr valign="top">
						<td>
							<a href="https://herowp.com/?ref=bbold-lite" target="_blank"><img src="<?php echo HEROWP_THEME_DIR.'/images/promo.png'; ?>" alt="Advertisement"></a>
						</td>
					</tr>
					
				</table>
				
				<p class="submit">
						<input type="submit" class="button-primary" value="<?php _e( 'Save Changes', 'bbold-lite' ); ?>" />
				</p>
			
			</form><!--END TABLE-->
			
	<?php }
}
?>