<?php 

add_action( 'add_meta_boxes', 'herowp_title_meta_box_add' );  

function herowp_title_meta_box_add() {  

    add_meta_box( 'my-meta-box-id', 'Subtitle of the page', 'herowp_title_meta_box_cb', 'page', 'normal', 'high' );  

} 

function herowp_title_meta_box_cb() {  

    // $post is already set, and contains an object: the WordPress post  

    global $post;  

    $values = get_post_custom( $post->ID );  
	
    $text = isset( $values['page_subtitle'] ) ? $values['page_subtitle'] : '';

    // We'll use this nonce field later on when saving.  

    wp_nonce_field( 'my_meta_box_nonce', 'meta_box_nonce' ); 

    ?> 

    <p> 

        <?php $value = get_post_custom(); ?>

        <label for="page_subtitle">Page subtitle</label> 

        <input type="text" name="page_subtitle" id="page_subtitle" value="<?php echo $value['page_subtitle'][0]; ?>" /> 

    </p> 

    <?php      

}  

add_action( 'save_post', 'herowp_title_meta_box_save' );  

function herowp_title_meta_box_save( $post_id )  {  

    // Bail if we're doing an auto save  

    if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return; 

     

    // if our nonce isn't there, or we can't verify it, bail 

    if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'my_meta_box_nonce' ) ) return; 

     

    // if our current user can't edit this post, bail  

    if( !current_user_can( 'edit_post' ) ) return;  

      

    // now we can actually save the data  

    $allowed = array(   

        'a' => array( // on allow a tags  

            'href' => array() // and those anchors can only have href attribute  

        )  

    );  

      

    // Make sure your data is set before trying to save it  

    if( isset( $_POST['page_subtitle'] ) )  

        update_post_meta( $post_id, 'page_subtitle', wp_kses( $_POST['page_subtitle'], $allowed ) ); 
}

?>