<?php
/************ SIDEBAR POSTS WIDGET ************/

add_action( 'widgets_init', 'bbold_f_widget3' );
function bbold_f_widget3() {
	register_widget('bbold_f_widget3');
}

class bbold_f_widget3 extends WP_Widget {
	function bbold_f_widget3() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'bbold_f_widget3', 'description' => 'Sidebar Posts' );
		 
		/* Widget control settings. */
		$control_ops = array( 'id_base' => 'bbold_f_widget3' );
		 
		/* Create the widget. */
		$this->WP_Widget( 'bbold_f_widget3', 'BBold Sidebar Posts', $widget_ops, $control_ops );
	}
	 
	function widget( $args, $instance ) {
		extract( $args );
		$post_no = $instance['post_no'] ;
		$title = $instance['title'] ;
	//	print_r ( $instance );
	?>
	
<?php $the_query = new WP_Query( 'showposts='.$post_no.' '); ?>
		<h3><?php echo $title; ?><span class="dotcolor">.</span></h3>
		
		<div class="footer-box-line2"></div>
		<div class="sidebar-posts-body">
			<?php while ($the_query -> have_posts()) : $the_query -> the_post(); ?>
				<div class="sidebar-posts-box">
					<div class="sidebar-post-thumb">
						<?php 
							if ( has_post_thumbnail() ) { 
							$id_img = get_post_thumbnail_id();
							$img_url = wp_get_attachment_url( $id_img,'full');
							$thumb = aq_resize($img_url, 100, 100, true); if ( !$thumb ) $thumb = $img_url;
						?>
						<a href="<?php the_permalink(); ?>" title="<?php printf( esc_attr__( 'Permalink to %s', 'bbold-lite' ), the_title_attribute('echo=0' ) ); ?>">
							<?php echo '<img src="'.$thumb.'" alt="'.get_the_title().'" class="categ-thumb"/>';?>
						</a>	
						<?php }  
						else {
						echo '<img src="http://dummyimage.com/100x100/e3e3e3/6b6b6b.png" width="100" height="100" alt="' . esc_attr( get_the_title() ) . '">';
							}
						?>					
					</div>
					<div class="sidebar-posts">
						<h2><a href="<?php the_permalink() ?>"><?php the_title(); ?><span class="dotcolor">.</span></a></h2>
						<p><span class="comments_sidebar"><?php the_author(); ?> // <?php $category = get_the_category(); echo $category[0]->cat_name;?></p>
					</div>
					
					<div class="date_holder">
						<span><?php echo the_time('d'); ?></span>
						<span class="month"><?php echo the_time('M'); ?></span>
					</div>
				</div>
			<?php endwhile;?>	
		</div>
		
<?php	
}
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		 
		/* Strip tags (if needed) and update the widget settings. */
		$instance['title'] =  $new_instance['title'];
		$instance['post_no'] =  $new_instance['post_no'];
		return $instance;
	}
	 
	function form( $instance ) {
		/* Set up some default widget settings. */
		$defaults = array( 'content' => '');
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>">Title:</label>
		<textarea class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>"><?php echo $instance['title']; ?></textarea>
		</p>
		
		<p>
		<label for="<?php echo $this->get_field_id( 'post_no' ); ?>">Number of posts:</label>
		<textarea class="widefat" id="<?php echo $this->get_field_id( 'post_no' ); ?>" name="<?php echo $this->get_field_name( 'post_no' ); ?>"><?php echo $instance['post_no']; ?></textarea>
		</p>
		
	<?php
	}
}


/************ SIDEBAR CATEGORIES  WIDGET ************/

add_action( 'widgets_init', 'bbold_f_widget4' );
function bbold_f_widget4() {
	register_widget('bbold_f_widget4');
}

class bbold_f_widget4 extends WP_Widget {
	function bbold_f_widget4() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'bbold_f_widget4', 'description' => 'Sidebar Categories' );
		 
		/* Widget control settings. */
		$control_ops = array( 'id_base' => 'bbold_f_widget4' );
		 
		/* Create the widget. */
		$this->WP_Widget( 'bbold_f_widget4', 'BBold Sidebar Categories', $widget_ops, $control_ops );
	}
	 
	function widget( $args, $instance ) {
		extract( $args );
		$title = $instance['title'] ;
	//	print_r ( $instance );
	?>
	
<h3><?php echo $title; ?><span class="dotcolor">.</span></h3>

<div class="footer-box-line2"></div>
<?php
	$args = array(
	  'orderby' => 'name',
	  'order' => 'ASC'
	  );
	$categories = get_categories($args);
	echo'<div class="sidebar_cat_list">';
	  foreach($categories as $category) { 
		echo '
		<div class="sidebar_cat">
			<i class="fa fa-bars"></i> <a href="' . get_category_link( $category->term_id ) . '" class="cat-name" title="' . sprintf( __( "View all posts in %s",'bbold-lite' ), $category->name ) . '" ' . '>' . $category->name.'</a> 
			
		</div>';
		} 
	echo '</div>';
?>
	
	
	
		
<?php	
}
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		 
		/* Strip tags (if needed) and update the widget settings. */
		$instance['title'] =  $new_instance['title'];
		return $instance;
	}
	 
	function form( $instance ) {
		/* Set up some default widget settings. */
		$defaults = array( 'content' => '');
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>">Widget Title:</label>
		<textarea class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>"><?php echo $instance['title']; ?></textarea>
		</p>
		
		
	
	<?php
	}
}




add_action( 'widgets_init', 'bbold_contact_widget' );
function bbold_contact_widget() {
	register_widget('bbold_contact_widget');
}

class bbold_contact_widget extends WP_Widget {
	function bbold_contact_widget() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'bbold_contact_widget', 'description' => 'Contact form widget.' );
		 
		/* Widget control settings. */
		$control_ops = array( 'id_base' => 'bbold_contact_widget' );
		 
		/* Create the widget. */
		$this->WP_Widget( 'bbold_contact_widget', 'BBold-Contact Widget', $widget_ops, $control_ops );
	}
	 
	function widget( $args, $instance ) {
		$instance['introtext']='';
		extract( $args );
		echo '<div class="widget-contact-form">';
		echo '<h3>'.$instance['title'].'<span class="dotcolor">.</span></h3>
		
		<div class="footer-box-line2"></div>
		';
		echo $instance['introtext'].'<div class="widget-contact-ct"><p>';
		if($instance['content']) { echo ' '.$instance['content'].''; } 
		echo '</p></div>';
		echo '<div class="widget-ct-social"><div class="wid-title-line"></div><div class="wid-title"><h3>'.$instance['social_title'].'</h3></div><div class="clear"></div>';
		echo '<div class="widget-box"><div class="contact-facebook"><i class="fa fa-facebook"></i><a href="'.$instance['social_facebook'].'">Follow us on Facebook</a></div>';
		echo '<div class="contact-twitter"><i class="fa fa-twitter"></i><a href="'.$instance['social_twitter'].'">Get latest updates from Twitter</a></div>';
		echo '<div class="contact-google"><i class="fa fa-google-plus"></i><a href="'.$instance['social_google'].'">Get in touch with us by Google</a></div></div>';
		echo '</div></div>';
	}
	 
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		 
		/* Strip tags (if needed) and update the widget settings. */
		$instance['title'] =  $new_instance['title'];
		$instance['content'] =  $new_instance['content'];
		$instance['social_title'] =  $new_instance['social_title'];
		$instance['social_facebook'] =  $new_instance['social_facebook'];
		$instance['social_twitter'] =  $new_instance['social_twitter'];
		$instance['social_google'] =  $new_instance['social_google'];
		
		
		return $instance;
	}
	 
	function form( $instance ) {
		/* Set up some default widget settings. */
		$defaults = array( 'content' => '');
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>">Box Title:</label>
		<textarea class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>"><?php echo $instance['title']; ?></textarea>
		</p>
		
		<p>
		<label for="<?php echo $this->get_field_id( 'content' ); ?>">Box Content:</label>
		<textarea class="widefat" id="<?php echo $this->get_field_id( 'content' ); ?>" name="<?php echo $this->get_field_name( 'content' ); ?>"><?php echo $instance['content']; ?></textarea>
		</p>
		
		<p>
		<label for="<?php echo $this->get_field_id( 'social_title' ); ?>">Social Box Title:</label>
		<textarea class="widefat" id="<?php echo $this->get_field_id( 'social_title' ); ?>" name="<?php echo $this->get_field_name( 'social_title' ); ?>"><?php echo $instance['social_title']; ?></textarea>
		</p>
		
		<p>
		<label for="<?php echo $this->get_field_id( 'social_facebook' ); ?>">Facebook Link:</label>
		<textarea class="widefat" id="<?php echo $this->get_field_id( 'social_facebook' ); ?>" name="<?php echo $this->get_field_name( 'social_facebook' ); ?>"><?php echo $instance['social_facebook']; ?></textarea>
		</p>
		
		<p>
		<label for="<?php echo $this->get_field_id( 'social_twitter' ); ?>">Twitter Link:</label>
		<textarea class="widefat" id="<?php echo $this->get_field_id( 'social_twitter' ); ?>" name="<?php echo $this->get_field_name( 'social_twitter' ); ?>"><?php echo $instance['social_twitter']; ?></textarea>
		</p>
		
		<p>
		<label for="<?php echo $this->get_field_id( 'social_google' ); ?>">Google Link:</label>
		<textarea class="widefat" id="<?php echo $this->get_field_id( 'social_google' ); ?>" name="<?php echo $this->get_field_name( 'social_google' ); ?>"><?php echo $instance['social_google']; ?></textarea>
		</p>
	<?php
	}
}

//About us widget
class about_us_widget extends WP_Widget {

    // Create Widget
    function about_us_widget() {
        parent::WP_Widget(false, $name = 'BBold - About Us', array('description' => ''));
    }

    // Widget Content
    function widget($args, $instance) { 
        extract( $args );
      
        $title = strip_tags($instance['title']);
        $first_text = esc_textarea($instance['first_text']);
        $second_text = esc_textarea($instance['second_text']);
        $facebook = strip_tags($instance['facebook']);
        $twitter = strip_tags($instance['twitter']);
        $deviantart = strip_tags($instance['deviantart']);
        $googleplus = strip_tags($instance['googleplus']);
       

        ?>
		
		
			<div class="footer-box-title">
				<h3><?php echo $title; ?><span class="dotcolor">.</span></h3>
				<div class="footer-box-line2"></div>
			</div>
			
			<div class="footer-box-content"><!--FOOTER BOX CONTENT START-->	
				<p><?php echo html_entity_decode($first_text); ?></p>
				<p class="bold"><?php echo html_entity_decode($second_text); ?></p>
				
					<div class="header-social footer-social"><!--SOCIAL START-->
						<ul>
							 							 <li class="facebook"><a href="<?php echo $facebook; ?>" target="_blank"><i class="fa fa-facebook"></i></a></li>
							 							 
							 							 <li class="twitter"><a href="<?php echo $twitter; ?>" target="_blank"><i class="fa fa-twitter"></i></a></li>
							 							 
														 <li class="deviantart"><a href="<?php echo $deviantart; ?>" target="_blank"><i class="fa fa-deviantart"></i></a></li>
							 							 
							 							 <li class="google-plus"><a href="<?php echo $googleplus; ?>" target="_blank"><i class="fa fa-google-plus"></i></a></li>				 
							 						 
						</ul>
					</div>				
			</div>


        <?php
     }

    // Update and save the widget
    function update($new_instance, $old_instance) {
        return $new_instance;
    }

    // If widget content needs a form
    function form($instance) {
        //widgetform in backend
     
        $title = strip_tags($instance['title']);
        $first_text = esc_textarea($instance['first_text']);
        $second_text = esc_textarea($instance['second_text']);
        $facebook = strip_tags($instance['facebook']);
        $twitter = strip_tags($instance['twitter']);
        $deviantart = strip_tags($instance['deviantart']);
        $googleplus = strip_tags($instance['googleplus']);
       
        ?>
          
          
            <p>
                <label for="<?php echo $this->get_field_id('title'); ?>">Title</label>
                <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" />
            </p>
			
			<p>
                <label for="<?php echo $this->get_field_id('first_text'); ?>">First text</label>
				<textarea class="widefat" rows="10" cols="20" id="<?php echo $this->get_field_id('first_text'); ?>" name="<?php echo $this->get_field_name('first_text'); ?>"><?php echo $first_text; ?></textarea>
            </p>
			
			<p>
                <label for="<?php echo $this->get_field_id('second_text'); ?>">Second text</label>
				<textarea class="widefat" rows="10" cols="20" id="<?php echo $this->get_field_id('second_text'); ?>" name="<?php echo $this->get_field_name('second_text'); ?>"><?php echo $second_text; ?></textarea>
            </p>
			
			<p>
                <label for="<?php echo $this->get_field_id('facebook'); ?>">Facebook URL</label>
                <input class="widefat" id="<?php echo $this->get_field_id('facebook'); ?>" name="<?php echo $this->get_field_name('facebook'); ?>" type="text" value="<?php echo esc_attr($facebook); ?>" />
            </p>
			
			<p>
                <label for="<?php echo $this->get_field_id('twitter'); ?>">Twitter URL</label>
                <input class="widefat" id="<?php echo $this->get_field_id('twitter'); ?>" name="<?php echo $this->get_field_name('twitter'); ?>" type="text" value="<?php echo esc_attr($twitter); ?>" />
            </p>
			
			<p>
                <label for="<?php echo $this->get_field_id('deviantart'); ?>">Deviantart URL</label>
                <input class="widefat" id="<?php echo $this->get_field_id('deviantart'); ?>" name="<?php echo $this->get_field_name('deviantart'); ?>" type="text" value="<?php echo esc_attr($deviantart); ?>" />
            </p>
			
			<p>
                <label for="<?php echo $this->get_field_id('googleplus'); ?>">Google URL </label>
                <input class="widefat" id="<?php echo $this->get_field_id('googleplus'); ?>" name="<?php echo $this->get_field_name('googleplus'); ?>" type="text" value="<?php echo esc_attr($googleplus); ?>" />
            </p>
			
			
            
          

        <?php       
    }

}

register_widget('about_us_widget');



//About us widget
class bold_text_widget extends WP_Widget {

    // Create Widget
    function bold_text_widget() {
        parent::WP_Widget(false, $name = 'BBold - Bold Text', array('description' => ''));
    }

    // Widget Content
    function widget($args, $instance) { 
        extract( $args );
      
        $title = esc_textarea($instance['title']);


        ?>
		
			
				<h1 class="bold_text_widget"><?php echo html_entity_decode($title); ?></h1>
		

        <?php
     }

    // Update and save the widget
    function update($new_instance, $old_instance) {
        return $new_instance;
    }

    // If widget content needs a form
    function form($instance) {
        //widgetform in backend
     
        $title = esc_textarea($instance['title']);
       
        ?>
          		
			<p>
                <label for="<?php echo $this->get_field_id('title'); ?>">Enter text using &#x3C;br /&#x3E; to add words to a new line.</label>
				<textarea class="widefat" rows="10" cols="20" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>"><?php echo $title; ?></textarea>
            </p>
		         
        <?php       
    }

}

register_widget('bold_text_widget');